class Topic < ActiveRecord::Base
  has_and_belongs_to_many :learning_objects

  has_many :topic_relationships, foreign_key: "parent_id"
  has_many :subtopics, through: :topic_relationships, source: :child

  has_many :topic_highlights
  has_many :highlights, through: :topic_highlights, source: :learning_object

  def self.default_list
    ['Artes', 'Biologia', 'Ciências', 'Educação Física', 'Filosofia',
     'Física', 'Geografia', 'História', 'Matemática', 'Língua Portuguesa', 'Química', 'Sociologia'].map do |topic|
      Topic.find_by_name(topic)
    end
  end
end
