namespace :convert do

  desc "Convert videos to mp4"
  task :video => :environment do
    include RepositoriesProxy

    # Quantity of items fetched on each iteration
    limit = 500

    # Start point from where items will be fetched
    offset = 0

    loop do

      begin
        # Get items from dspace (from offset to offset+limit)
        items = learning_object_repository.all_from_offset_to_limit(offset,limit)
      rescue
        # Sleeps for a while to wait database's recovery
        sleep(10.seconds)
        # Goes to next iteration to retry
        next
      else
        # Terminate loop if there are no more items to import
        break if items.empty?

        items.each do |item|
          item.attachments.each do |attachment|
            if attachment.name =~ /(.flv|.wmv|.mov|.mpg)$/i
              ConvertVideoWorker.perform_async(item.id)
              p "Convert learning object #{item.id}"
            end
          end
        end

        # Increment offset, to get new items on next iteration
        offset += limit
      end
    end
  end

end
